package sgc.portal.cw.cw0626.service;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import sgc.portal.base.util.EasyHashMap;
import sgc.portal.base.websquare.GridRowStatus;
import sgc.portal.cw.cw0626.dto.CW06260001USearch;
import sgc.portal.cw.cw0626.model.CW06260001U;
import sgc.portal.cw.cw0626.persistence.CW06260001UMapper;

import java.time.LocalDateTime;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class CW06260001UService {
    private final CW06260001UMapper mapper;

    public CW06260001UService(CW06260001UMapper mapper) {
        this.mapper = mapper;
    }

    public List<EasyHashMap<String, Object>> getList(CW06260001USearch search) {
        return mapper.getList(search);
    }

    @Transactional
    public Map<String, String> save(List<CW06260001U> CW06260001U) {
    	
    	Map<String,String> result = new HashMap<>();
    	
    	for (CW06260001U cW06260001U : CW06260001U) {
            switch (cW06260001U.getRowStatus()) {
                case GridRowStatus.CREATED:
                    insert(cW06260001U);
                    break;
                case GridRowStatus.UPDATED:
                    update(cW06260001U);
                    break;
                case GridRowStatus.DELETED:
                    delete(cW06260001U);
                    break;
                default:
                    break;
            }
        }
    	return result;
    }

    private void insert(CW06260001U cW06260001U) {
    	if(cW06260001U.getSeq() == null) {
    		int seq = mapper.selectSeq(cW06260001U);
    		cW06260001U.setSeq(seq);
    		cW06260001U.setSubSeq(1);
            mapper.insert(cW06260001U);
    	}else {
    		if(cW06260001U.getSubSeq() == null) {
        		int subSeq = mapper.selectSubSeq(cW06260001U);
        		cW06260001U.setSubSeq(subSeq);
                mapper.insert(cW06260001U);
    		}
    	}
    }

    private void update(CW06260001U cW06260001U) {
        mapper.update(cW06260001U);
    }

    private void delete(CW06260001U cW06260001U) {
        mapper.delete(cW06260001U);
    }
}
